
TUNING.HEALTH_LOSE_COLOR = { 
	r = 0.7, 
	g = 0, 
	b = 0 
}
TUNING.HEALTH_GAIN_COLOR = {
	r = 0,
	g = 0.7,
	b = 0 
}


TUNING.LABEL_FONT_SIZE = 70

TUNING.LABEL_Y_START = 4

TUNING.LABEL_TIME = 1.0

TUNING.LABEL_TIME_DELTA = 0.01

TUNING.GRAVITY = 0.1
TUNING.FRICTION_PRESERVE = 0.9

TUNING.LIFT_ACC = 0.003
TUNING.SIDE_WAVE_RND = 0.15
TUNING.LABEL_Y_START_VELO = 0.05

TUNING.LABEL_MIN_AMPLITUDE_X = 0.8
TUNING.LABEL_MAX_AMPLITUDE_X = 1.6


local function CreateLabel(inst, parent)
	inst.persists = false
	if not inst.Transform then
		inst.entity:AddTransform()
	end
	inst.Transform:SetPosition( parent.Transform:GetWorldPosition() )

	return inst
end

local function CreateDamageIndicator(parent, amount)
	local inst = CreateLabel(GLOBAL.CreateEntity(), parent)

	local label = inst.entity:AddLabel()
	label:SetFont(GLOBAL.NUMBERFONT)
	label:SetFontSize( TUNING.LABEL_FONT_SIZE )
	label:SetPos(0, TUNING.LABEL_Y_START, 0)

	local color
	if amount < 0 then
		color = TUNING.HEALTH_LOSE_COLOR
	else
		color = TUNING.HEALTH_GAIN_COLOR
	end

	label:SetColour(color.r, color.g, color.b)

	label:SetText( ("%d"):format(amount) )  -- wanna have .x ?

	label:Enable(true)

	inst:StartThread(function()

		local label = inst.Label

		local t = 0
		local t_max = TUNING.LABEL_TIME
		local dt = TUNING.LABEL_TIME_DELTA

		-- swirr upon mode ------------------
		local y = TUNING.LABEL_Y_START
		local dy = TUNING.LABEL_Y_START_VELO
		local ddy = 0.0
		
		local side = (math.random() * (TUNING.LABEL_MAX_AMPLITUDE_X - TUNING.LABEL_MIN_AMPLITUDE_X) + TUNING.LABEL_MIN_AMPLITUDE_X) * (math.random() >= 0.5 and -1 or 1)
		local dside = 0.0
		local ddside = 0.0
		-------------------------------------

		-- bounce around mode ---------------
		-- local y = TUNING.LABEL_Y_START
		-- local dy = 0.05
		-- local ddy = 0.0
		
		-- local side = 0.0
		-- local dside = 0.1
		-- local ddside = 0.0
		-------------------------------------

		while inst:IsValid() and t < t_max do
		
			-- swirr upon mode ------------------
			ddy = TUNING.LIFT_ACC * (math.random() * 0.5 + 0.5)
			dy = dy + ddy
			y = y + dy
			
			ddside = -side * math.random()*TUNING.SIDE_WAVE_RND
			dside = dside + ddside
			side = side + dside
			-------------------------------------
			
			-- bounce around mode ---------------
			-- ddy = -TUNING.GRAVITY
			-- dy = dy + ddy
			-- y = y + dy
			-- if y < 0 then
				-- y = -y
				-- dy = -dy * TUNING.FRICTION_PRESERVE
			-- end
			
			-- ddside = 0
			-- dside = dside + ddside
			-- side = side + dside
			-------------------------------------
		
			local headingtarget = 45 --[[TheCamera.headingtarget]] % 180
			if headingtarget == 0 then 
				label:SetPos(0, y, side)  		-- from 3d plane x = 0
			elseif headingtarget == 45 then
				label:SetPos(side, y, -side)	-- from 3d plane x + z = 0
			elseif headingtarget == 90 then
				label:SetPos(side, y, 0)		-- from 3d plane z = 0
			elseif headingtarget == 135 then
				label:SetPos(side, y, side)		-- from 3d plane z - x = 0
			end
			t = t + dt
			label:SetFontSize( TUNING.LABEL_FONT_SIZE * math.sqrt(1 - t / t_max))
			GLOBAL.Sleep(dt)
		end

		inst:Remove()
	end)

	return inst
end


AddComponentPostInit("health", function(Health, inst)
	inst:ListenForEvent("healthdelta", function(inst, data)
		if inst.components.health then
			local amount = (data.newpercent - data.oldpercent)*inst.components.health.maxhealth
			if math.abs(amount) > 0.001 then
				CreateDamageIndicator(inst, amount)
			end
		end
	end)
end)
